searchNodes=[{"doc":"","ref":"Request.Validator.html","title":"Request.Validator","type":"behaviour"},{"doc":"Determine if the user is authorized to make this request.def authorize(conn) do user(conn).is_admin end","ref":"Request.Validator.html#c:authorize/1","title":"Request.Validator.authorize/1","type":"callback"},{"doc":"Get the validation rules that apply to the request.","ref":"Request.Validator.html#c:rules/1","title":"Request.Validator.rules/1","type":"callback"},{"doc":"","ref":"Request.Validator.Helper.html","title":"Request.Validator.Helper","type":"module"},{"doc":"","ref":"Request.Validator.Helper.html#define_rule/2","title":"Request.Validator.Helper.define_rule/2","type":"macro"},{"doc":"","ref":"Request.Validator.Helper.html#with_param/2","title":"Request.Validator.Helper.with_param/2","type":"macro"},{"doc":"","ref":"Request.Validator.Plug.html","title":"Request.Validator.Plug","type":"module"},{"doc":"Performs validations on conn.params If all validations are successful returns the connection struct Otherwise returns an error map in the following structure: %{param: [&quot;some error&quot;, ...]} Will call the given on_error callback in case some validation failed","ref":"Request.Validator.Plug.html#call/2","title":"Request.Validator.Plug.call/2","type":"function"},{"doc":"Init the Request.Validation.Plug with an optional error callback and handlers with their corresponding request validator module.plug Request.Validation.Plug, register: App.Requests.RegisterRequest, on_error: fn conn, errors -&gt; json_resp(conn, &quot;Handle your errors: \#{inspect errors}&quot;) end","ref":"Request.Validator.Plug.html#init/1","title":"Request.Validator.Plug.init/1","type":"function"},{"doc":"The default callback to be invoked when there is a param that fails validation.","ref":"Request.Validator.Plug.html#on_error/2","title":"Request.Validator.Plug.on_error/2","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html","title":"Request.Validator.Rules","type":"module"},{"doc":"","ref":"Request.Validator.Rules.html#bail/1","title":"Request.Validator.Rules.bail/1","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html#is_confirmed/0","title":"Request.Validator.Rules.is_confirmed/0","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html#is_email/0","title":"Request.Validator.Rules.is_email/0","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html#is_gt/1","title":"Request.Validator.Rules.is_gt/1","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html#is_lt/1","title":"Request.Validator.Rules.is_lt/1","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html#is_max/1","title":"Request.Validator.Rules.is_max/1","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html#is_min/1","title":"Request.Validator.Rules.is_min/1","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html#is_numeric/0","title":"Request.Validator.Rules.is_numeric/0","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html#is_required/0","title":"Request.Validator.Rules.is_required/0","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html#is_string/0","title":"Request.Validator.Rules.is_string/0","type":"function"},{"doc":"","ref":"Request.Validator.Rules.Bail.html","title":"Request.Validator.Rules.Bail","type":"module"},{"doc":"RequestValidatorA blazing fast request validator for your phoenix app, which validates a request body before hitting the request handler in the controller.","ref":"readme.html","title":"RequestValidator","type":"extras"},{"doc":"The package can be installed by adding request_validator to your list of dependencies in mix.exs:def deps do [ {:request_validator, &quot;~&gt; 0.4.0-alpha.1&quot;} ] end","ref":"readme.html#installation","title":"RequestValidator - Installation","type":"extras"},{"doc":"defmodule App.UserController do use AppWeb, :controller plug Request.Validation.Plug, %{ login: App.Requests.Login, register: App.Requests.Registration } def login(conn, params) do ... end def register(conn, params) do ... end end defmodule App.Requests.Registration do use Request.Validator @behaviour Request.Validator @impl Request.Validator @spec rules(Plug.Conn.t()) :: map()|keyword() def rules(_) do %{ &quot;email&quot; =&gt; [:required, :email], &quot;name&quot; =&gt; [:required, :string], &quot;password&quot; =&gt; [:required, :string], &quot;age&quot; =&gt; [:required, :numeric, {:min, 18}] } end @impl Request.Validator @spec authorize(Plug.Conn.t()) :: boolean() def authorize(_), do: true end defmodule App.Requests.Login do use Request.Validator @behaviour Request.Validator @impl Request.Validator @spec rules(Plug.Conn.t()) :: map()|keyword() def rules(_) do %{ &quot;email&quot; =&gt; [:required, :email], &quot;password&quot; =&gt; [:required, :string] } end @impl Request.Validator @spec authorize(Plug.Conn.t()) :: boolean() def authorize(_), do: true endFull documentation can be found at https://hexdocs.pm/request_validator.","ref":"readme.html#basic-usage","title":"RequestValidator - Basic Usage","type":"extras"},{"doc":"In some cases, your application already makes use of the ecto library. I'm glad to tell you that this library has support when the rule method returns a Ecto.Changeset struct, so that you can make use of the advantages provided by this library without rewritting your validation logic. See example below:defmodule App.Requests.TestRequest do use Request.Validator use Ecto.Schema alias App.Requests.TestRequest import Ecto.Changeset @behaviour Request.Validator embedded_schema do field(:name, :string) field(:email, :string) field(:age, :integer) field(:password, :string) end @doc false defp changeset(contact, attrs) do contact |&gt; cast(attrs, [:name, :email, :age, :password]) |&gt; validate_required([:name, :email, :age, :password]) |&gt; validate_number(:age, less_than_or_equal_to: 32) end @impl Request.Validator def rules(conn) do %TestRequest{} |&gt; changeset(conn.params) end @impl Request.Validator @spec authorize(Plug.Conn.t())::boolean() def authorize(_), do: true end","ref":"readme.html#ecto-support","title":"RequestValidator - Ecto Support","type":"extras"},{"doc":"This library provides a variety of helpful rules, however, you might want to define some rules to house your validation logic. To achieve this, you need to create your own rules and validation messages module, see example/steps below;# lib/validations/rules.ex defmodule App.Validation.Rules do use Request.Validator.Rules use App.Repo alias App.Repo def exists(value, {model, field}, fields) do from model, where: [{field, value}] |&gt; Repo.exists end end # lib/validations/messages.ex defmodule App.Validation.Messages do @moduledoc false use Request.Validator.Messages, gettext: App.Gettext ... def exists(attr, params) do dgettext(&quot;validations&quot;, &quot;This %{field} doesn&#39;t exists.&quot;, field: attr) end endAfter the modules have been defined you will to set some configs to override the default modules used by the library.# config/config.exs use Mix.Config config :request_validator, rules: App.Validation.Rules, translator: App.Validation.MessagesAfter adding the rule which is a method, then you can make use of the rule in any of your request validator module. defmodule App.Requests.CourseRegistration do use Request.Validator @behaviour Request.Validator @impl Request.Validator @spec rules(Plug.Conn.t()) :: map()|keyword() def rules(_) do %{ &quot;email&quot; =&gt; [:required, :email], &quot;name&quot; =&gt; [:required, :string], &quot;age&quot; =&gt; [:required, :numeric, {:min, 18}], &quot;course&quot; =&gt; [:required, :string, {:exists, {App.Course, :id}}] } end @impl Request.Validator @spec authorize(Plug.Conn.t()) :: boolean() def authorize(_), do: true end","ref":"readme.html#custom-validation-rules","title":"RequestValidator - Custom Validation Rules","type":"extras"},{"doc":"Below is a list of all available validation rules and their function:emailThe field under validation must be formatted as an e-mail address{gt, field}The field under validation must be greater than the given field. The two fields must be of the same type{lt, field}The field under validation must be less than the given field. The two fields must be of the same type{max, value}The field under validation must be less than or equal to a maximum value. Supported types are strings, numerics and list.{min, value}The field under validation must have a minimum value. Supported types are strings, numerics and list.numericThe field under validation must be numeric.requiredThe field under validation must be present in the input data and not empty. A field is considered &quot;empty&quot; if one of the following conditions are true:The value is nil.The value is an empty string.The value is an empty list or map.stringThe field under validation must be a string.{same, field}The given field must match the field under validation.","ref":"readme.html#rules","title":"RequestValidator - Rules","type":"extras"},{"doc":"[ ] Include more validation rules[ ] Norm validation support[x] Ecto schema support","ref":"readme.html#todos","title":"RequestValidator - TODOS","type":"extras"},{"doc":"RequestValidator is released under the MIT License - see the LICENSE file.","ref":"readme.html#license","title":"RequestValidator - License","type":"extras"},{"doc":"MIT License Copyright (c) 2020 atanda rasheed Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]